/*

DU4SEM.CPP

JY

Mlaskal's semantic interface for DU4

*/

#include "du4sem.h"
#include "du4tok.h"
#include "du4.h"
#include "duerr.h"

namespace mlc {

/*
	void 
	make_const_from_id(MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, mlc::ls_id_type::const_pointer val, int l_id, int l_val) {

		mlc::symbol_pointer sp = ctx->tab->find_symbol(val);
		if ( sp->kind() != SKIND_CONST ) {
			error( DUERR_NOTCONST, l_val, *val);
		} else {
			bool bval;
			mlc::ls_int_index iptr;
			mlc::ls_real_index rptr;
			mlc::ls_str_index sptr;
			switch(sp->access_typed()->type()->cat()) {
				case mlc::TCAT_BOOL:
					bval = sp->access_const()->access_bool_const()->bool_value();
					ctx->tab->add_const_bool(l_id, id, bval);
					break;
				case mlc::TCAT_INT:
					iptr = sp->access_const()->access_int_const()->int_value();
					ctx->tab->add_const_int(l_id, id, iptr);
					break;
				case mlc::TCAT_REAL:
					rptr = sp->access_const()->access_real_const()->real_value();
					ctx->tab->add_const_real(l_id, id, rptr);
					break;
				case mlc::TCAT_STR:
					sptr = sp->access_const()->access_str_const()->str_value();
					ctx->tab->add_const_str(l_id, id, sptr);
					break;
				case TCAT_UNDEF:
				case TCAT_ARRAY:
				case TCAT_RECORD:
				case TCAT_RANGE:
				default:
					assert(false);
					break;
			}
		}

	}

	void
	make_const_int(mlc::MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, int sign, mlc::ls_int_type::const_pointer val, int l_id, int l_val) {

		switch(sign) {
			case DUTOKGE_PLUS:
				ctx->tab->add_const_int(l_id, id, val);
				break;
			case DUTOKGE_MINUS:
				mlc::ls_int_type::const_pointer nval = ctx->tab->ls_int().add( - *val);
				ctx->tab->add_const_int(l_id, id, nval);
				break;
		}
	}

	void
	make_const_real(mlc::MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, int sign, mlc::ls_real_type::const_pointer val, int l_id, int l_val) {
		switch(sign) {
			case DUTOKGE_PLUS:
				ctx->tab->add_const_real(l_id, id, val);
				break;
			case DUTOKGE_MINUS:
				mlc::ls_real_type::const_pointer nval = ctx->tab->ls_real().add( - *val);
				ctx->tab->add_const_real(l_id, id, nval);
				break;
		}
	}


	mlc::ls_int_type::const_pointer
	ord_const_from_id(MlaskalCtx* ctx, int sign, mlc::ls_id_type::const_pointer id, int l_id) {

		mlc::symbol_pointer sp = ctx->tab->find_symbol(id);
		//mlc::ls_int_type::const_pointer ci;

		if ( sp->kind() != SKIND_CONST ) {
			error( DUERR_NOTCONST, l_id, *id);
		} else if(sp->access_typed()->type()->cat() != TCAT_INT) {
			error( DUERR_NOTINTEGRAL, l_id, *id);
			//TODO character const?
		} else {
			switch(sign) {
				case DUTOKGE_PLUS:
					return sp->access_const()->access_int_const()->int_value();
					break;
				case DUTOKGE_MINUS:
					return ctx->tab->ls_int().add( - *sp->access_const()->access_int_const()->int_value());
					break;
			}
		}
		return sp->access_const()->access_int_const()->int_value(); // just to shut them up
	}

	mlc::ls_int_type::const_pointer
	ord_const_from_uint(MlaskalCtx* ctx, int sign, mlc::ls_int_type::const_pointer int_ci, int l_int) {
		if(sign == DUTOKGE_MINUS) {
			return ctx->tab->ls_int().add( - *int_ci);
		}

		return int_ci;
	}

	mlc::type_pointer
	range_from_id_ord_const(mlc::MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id_lower, mlc::ls_int_type::const_pointer int_upper, int l_lower )  {

		mlc::ls_int_type::const_pointer int_lower = ord_const_from_id(ctx, DUTOKGE_PLUS, id_lower, l_lower);

		if(*int_lower > *int_upper) {
			error( DUERR_BADRANGE, l_lower);
		}

		// create range, even if it is invalid
		return ctx->tab->create_range_type(int_lower, int_upper);
	}

	mlc::type_pointer
	range_from_ord_const_ord_const(mlc::MlaskalCtx* ctx, mlc::ls_int_type::const_pointer int_lower, mlc::ls_int_type::const_pointer int_upper, int l_lower)  {

		if(*int_lower > *int_upper) {
			error( DUERR_BADRANGE, l_lower);
		}

		// create range, even if it is invalid
		return ctx->tab->create_range_type(int_lower, int_upper);
	}

	void
	var_from_vec(mlc::MlaskalCtx* ctx, const id_ci_vec & vars, mlc::type_pointer type) {

		for(id_ci_vec_criter rit = vars.rbegin(); rit != vars.rend(); ++rit) {
			ctx->tab->add_var(rit->second, rit->first, type);
		}
	}

	mlc::type_pointer
	get_scalar_type(MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, int l_id) {
		mlc::symbol_pointer sp = ctx->tab->find_symbol(id);
		if(sp->kind() != mlc::SKIND_TYPE) {
			error(DUERR_NOTTYPE, l_id, *id);
		}
		// ???
		switch(sp->access_typed()->type()->cat()) {
			case TCAT_BOOL:
			case TCAT_INT:
			case TCAT_REAL:
			case TCAT_STR:
			case TCAT_UNDEF:
			case TCAT_ARRAY:
			case TCAT_RECORD:
			case TCAT_RANGE:
				break;
		}

		return sp->access_typed()->type();
	}

	mlc::type_pointer
	get_type(MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, int l_id) {
		mlc::symbol_pointer sp = ctx->tab->find_symbol(id);
		if(sp->kind() != SKIND_TYPE) {
			error(DUERR_NOTTYPE, l_id, *id);
		}

		return sp->access_typed()->type();
	}

	void
	params_append_byref(mlc::parameter_list* params, const id_ci_vec & ids, mlc::type_pointer type) {
		for(id_ci_vec_citer it = ids.begin(); it != ids.end(); ++it) {
			params->append_parameter_by_reference(it->first, type);
		}
	}

	void
	params_append_byval(mlc::parameter_list* params, const id_ci_vec & ids, mlc::type_pointer type) {
		for(id_ci_vec_citer it = ids.begin(); it != ids.end(); ++it) {
			params->append_parameter_by_value(it->first, type);
		}
	}
*/
}
