/*
 * frantisek farka
 */

#ifndef __DU4SEM_H
#define __DU4SEM_H

#include "du5.h"
#include "du5lval.hpp"

namespace mlc {
	
	void make_const_from_id(mlc::MlaskalCtx*, mlc::ls_id_type::const_pointer, mlc::ls_id_type::const_pointer, int, int);
	void make_const_int(mlc::MlaskalCtx*, mlc::ls_id_type::const_pointer, int, mlc::ls_int_type::const_pointer, int);
	void make_const_real(mlc::MlaskalCtx*, mlc::ls_id_type::const_pointer, int, mlc::ls_real_type::const_pointer, int);

	mlc::ls_int_type::const_pointer ord_const_from_id(mlc::MlaskalCtx*, int sign, mlc::ls_id_type::const_pointer id_ci, int l_id);
	mlc::ls_int_type::const_pointer ord_const_from_uint(mlc::MlaskalCtx*, int sign, mlc::ls_int_type::const_pointer int_ci);
	mlc::type_pointer range_from_id_ord_const(mlc::MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id_lower, mlc::ls_int_type::const_pointer int_upper, int l_lower );
	mlc::type_pointer range_from_ord_const_ord_const(mlc::MlaskalCtx* ctx, mlc::ls_int_type::const_pointer int_lower, mlc::ls_int_type::const_pointer int_upper, int l_lower );

	void var_from_vec(mlc::MlaskalCtx* ctx, const id_ci_vec & vars, mlc::type_pointer type);

	mlc::type_pointer get_type(MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, int l_id);
	mlc::type_pointer get_scalar_type(MlaskalCtx* ctx, mlc::ls_id_type::const_pointer id, int l_id);

	void params_append_byref(mlc::parameter_list* params, const id_ci_vec & ids, mlc::type_pointer type);
	void params_append_byval(mlc::parameter_list* params, const id_ci_vec & ids, mlc::type_pointer type);

	/*******************************************************/

	void expr_deref(MlaskalCtx*, MlaskalExpr &);
	void expr_deptr(MlaskalExpr &);

	void add_gstx(MlaskalCtx*, MlaskalExpr &, mlc::ls_id_type::const_pointer, int);
	void add_lstx(MlaskalCtx*, MlaskalExpr &, mlc::ls_id_type::const_pointer, int);
	void add_fncret(MlaskalCtx*, MlaskalExpr &, mlc::ls_id_type::const_pointer, int);

	void call_proc(MlaskalCtx*, mlc::icblock_pointer, mlc::subprogram_symbol_pointer, expr_vec, mlc::ls_id_type::const_pointer, int);
	void call_fun(MlaskalCtx*, mlc::icblock_pointer, mlc::subprogram_symbol_pointer, expr_vec, mlc::ls_id_type::const_pointer, int, bool b = false);
	
	void expr_add( MlaskalCtx* ctx, MlaskalExpr & res, MlaskalExpr & lop, MlaskalExpr & rop, int l_op);
	void expr_mul( MlaskalCtx* ctx, MlaskalExpr & res, MlaskalExpr & lop, MlaskalExpr & rop, int l_op);
	void expr_sub( MlaskalCtx* ctx, MlaskalExpr & res, MlaskalExpr & lop, MlaskalExpr & rop, int l_op);
	void expr_divr( MlaskalCtx* ctx, MlaskalExpr & res, MlaskalExpr & lop, MlaskalExpr & rop, int l_op);
	void expr_divi( MlaskalCtx* ctx, MlaskalExpr & res, MlaskalExpr & lop, MlaskalExpr & rop, int l_op);
	void expr_mod( MlaskalCtx* ctx, MlaskalExpr & res, MlaskalExpr & lop, MlaskalExpr & rop, int l_op);

	void add_xstx(MlaskalCtx*, mlc::icblock_pointer, MlaskalExpr &, MlaskalExpr &);
	void add_xldx(MlaskalExpr &);
	void add_minus(MlaskalExpr &, int);

	void arr_index(MlaskalCtx*, MlaskalExpr &, expr_vec &, bool);


}

#endif
